package uk.co.vault101.ritual;


import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.graphics.Texture.TextureFilter;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;

public class Background extends Actor {
	final TextureRegion region;
	
    public Background (final String asset, final int w, final int h) {
    	Texture texture = new Texture(Gdx.files.internal(asset));
    	texture.setFilter(TextureFilter.Linear, TextureFilter.Linear);
    	setBounds(getX(), getY(),texture.getWidth(),texture.getHeight());
		region = new TextureRegion(texture, 0, 0, w, h);
		setBounds(getX(), getY(),texture.getWidth(),texture.getHeight()); // crud from JailBreak ?
		
    }
	
    @Override
    public void act(final float delta) {
    	super.act(delta);
    }
    
    @Override
    public void draw(final Batch batch, final float parentAlpha) {
    	super.draw(batch, parentAlpha);
    	   Color color = getColor();
           batch.setColor(color.r, color.g, color.b, color.a * parentAlpha);
           batch.draw(region, getX(), getY(), getOriginX(), getOriginY(),
               getWidth(), getHeight(), getScaleX(), getScaleY(), getRotation());
    }
}
