package uk.co.vault101.ritual;

import static uk.co.vault101.ritual.Ritual.HEIGHT;
import static uk.co.vault101.ritual.Ritual.WIDTH;
import static com.badlogic.gdx.scenes.scene2d.actions.Actions.fadeIn;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.utils.viewport.StretchViewport;

public class InitialGraphicalComponent extends GraphicalComponent {

	private final String title = "Pentagram";
	private float th;
	
	public InitialGraphicalComponent(final Ritual display) {
		super(display);
		this.stage = new Stage();
		stage.setViewport(new StretchViewport(WIDTH,HEIGHT));
		font = new BitmapFont(Gdx.files.internal("fonts/vinque32.fnt"), Gdx.files.internal("fonts/vinque32.png"), false);
		glyphLayout.setText(font, "ABC");
		th = glyphLayout.height;
		
		final Actor background = new Background("images/gamestate.png", 1920, 1080);
		background.setSize(WIDTH, HEIGHT);
		background.setOrigin(WIDTH / 2, HEIGHT / 2);
		background.setPosition(0, 0);
		stage.addActor(background);
	}
	

	@Override
	public void setScreenRef(Screen screen) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	protected void update3D(final float delta) {

	}

	@Override
	protected void render3D(final float delta) {
        Gdx.gl.glClearColor(0.0f, 0.0f, 0, 1); // don't clear the colour bit if full screen overdraw of course :)
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
	}

	@Override
	protected void update2D(final float delta) {
		stage.act(delta);
	}

	@Override
	protected void render2D(final float delta) {

        stage.getBatch().setProjectionMatrix(stage.getCamera().combined);
     
        stage.draw();
        
    	stage.getBatch().begin();
    	
    	font.setColor(1.0f, 1.0f, 1.0f, 1.0f);
    	//glyphLayout.setText(font, title);
    	//font.draw(stage.getBatch(), title, (WIDTH/2)-(glyphLayout.width/2), HEIGHT-th);
    	stage.getBatch().end();
	}

	@Override
	public void show() {
		stage.getRoot().getColor().a = 0;
		stage.getRoot().addAction(fadeIn(0.5f));
		Gdx.input.setInputProcessor(stage);
	}

	@Override
	public void hide() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void pause() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void resume() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void resize(final int width, final int height) {
		// TODO : does Console stage exist at this point? If so, copy what's done in MenuGraphicalComponent.resize(w,h);
		stage.getViewport().update(width, height, true);
		stage.getCamera().position.set(WIDTH/2, HEIGHT/2, 0);
	}

	@Override
	public void dispose() {
		if (stage != null) {
			stage.dispose();
		}
	}
	
	public void nextScreen() {
		switchScreen(display, display.getGameState());
	}	
}
