package uk.co.vault101.ritual;

import uk.co.vault101.ritual.GraphicalComponent;

import com.badlogic.gdx.Screen;

public class InitialState implements Screen {

	private final GraphicalComponent gc;
	private boolean loadnext = false;
	protected long start;

	public InitialState(final GraphicalComponent gc) {
		this.gc = gc;
	}

	@Override
	public void dispose() {
		gc.dispose();
	}

	@Override
	public void hide() {
		gc.hide();
	}

	@Override
	public void pause() {
		gc.pause();
	}
	
	@Override
	public void render(final float delta) {
		gc.render(delta);
    	if (!loadnext && System.currentTimeMillis() - start >= 3000) {
			loadnext = true;
			gc.nextScreen();
		}
	}
	
	@Override
	public void resize(int width, int height) {
		gc.resize(width, height);
	}

	@Override
	public void resume() {
		gc.resume();
	}

	@Override
	public void show() {
		start = System.currentTimeMillis();
		gc.show();
	}
}
