package uk.co.vault101.ritual;

import java.util.HashSet;
import java.util.Set;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.utils.Logger;

public class Ritual extends Game {
	
	public static int WIDTH, HEIGHT;
	public static final long BORN = System.currentTimeMillis();
	
	/** States */
	private InitialState initialState;
	private GameState gameState;
	
	private final Set<Screen> screens = new HashSet<>(); 	

	@Override
	public void create () {
		WIDTH = Gdx.app.getGraphics().getWidth();
		HEIGHT = Gdx.app.getGraphics().getHeight();
		Gdx.app.setLogLevel(Logger.DEBUG);
		
		screens.add(initialState);
		screens.add(gameState);

		initialState = new InitialState(new InitialGraphicalComponent(this));
		setScreen(initialState);
	}
	
	@Override
	public void dispose() {
		super.dispose();
		
		for (final Screen s : screens) {
			if (s != null) {
				s.dispose();
			}
		}
	}
	
	public Screen getGameState() {
		if (gameState == null) {
			gameState = new GameState(new GameGraphicalComponent(this));
		}
		return gameState;
	}
	
	@Override
	public void resize(int width, int height) {
		super.resize(width, height);

	}
	
}
